//+------------------------------------------------------------------+
//|                                                        JFatl.mq5 |
//|                               Copyright  2010, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
//|     SmoothAlgorithms.mqh   |
//|   (): terminal_data_folder\\MQL5\Include         |
//+------------------------------------------------------------------+
#property copyright "2010,   Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"
//---     
#property indicator_chart_window
//---        
#property indicator_buffers 1
//---     
#property indicator_plots   1
//---     
#property indicator_type1   DRAW_LINE
//---        
#property indicator_color1  Blue
//---   -  
#property indicator_style1  STYLE_SOLID
//---     2
#property indicator_width1  2
//---   
#property indicator_label1  "JFATL"
//+-----------------------------------+
//|         |
//+-----------------------------------+
enum Applied_price_      // 
  {
   PRICE_CLOSE_ = 1,     //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simple Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   //TrendFollow_2 Price 
  };
input int Length_=5;                   //  JMA                    
input int Phase_=100;                  //  JMA 
input Applied_price_ IPC=PRICE_CLOSE_; //  
input int FATLShift=0;                 //  FATL    
input int PriceShift=0;                //  FATL    
//---         
int FATLPeriod=39;
//---   ,  
//---       
double ExtLineBuffer[];
//---
int start,fstart,FATLSize;
double dPriceShift;
//+------------------------------------------------+ 
//|      |
//+------------------------------------------------+ 
double FATLTable[]=
  {
   +0.4360409450, +0.3658689069, +0.2460452079, +0.1104506886,
   -0.0054034585, -0.0760367731, -0.0933058722, -0.0670110374,
   -0.0190795053, +0.0259609206, +0.0502044896, +0.0477818607,
   +0.0249252327, -0.0047706151, -0.0272432537, -0.0338917071,
   -0.0244141482, -0.0055774838, +0.0128149838, +0.0226522218,
   +0.0208778257, +0.0100299086, -0.0036771622, -0.0136744850,
   -0.0160483392, -0.0108597376, -0.0016060704, +0.0069480557,
   +0.0110573605, +0.0095711419, +0.0040444064, -0.0023824623,
   -0.0067093714, -0.0072003400, -0.0047717710, +0.0005541115,
   +0.0007860160, +0.0130129076, +0.0040364019
  };
//--- 
#include <SmoothAlgorithms.mqh>  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+ 
void OnInit()
  {
//---    ExtLineBuffer   
   SetIndexBuffer(0,ExtLineBuffer,INDICATOR_DATA);
//---       FATLShift
   PlotIndexSetInteger(0,PLOT_SHIFT,FATLShift);
//---   
   FATLSize=ArraySize(FATLTable);
   start=FATLSize+30;
//---      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,start);
//---      
   string shortname;
   StringConcatenate(shortname,"JFATL(",Length_," ,",Phase_,")");
//---      DataWindow
   PlotIndexSetString(0,PLOT_LABEL,shortname);
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//---      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);
//---    
   dPriceShift=_Point*PriceShift;
//---    CJJMA   JJMASeries_Cls.mqh
   CJJMA JMA;
//---       
   JMA.JJMALengthCheck("Length_", Length_);
   JMA.JJMAPhaseCheck("Phase_", Phase_);
//---
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(rates_total<start)
      return(0);
//---    
   int first,bar;
   double jfatl,FATL;
//---    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=FATLPeriod-1; //      
      fstart=first;
     }
   else first=prev_calculated-1; //      
//---    CJJMA   SmoothAlgorithms.mqh
   static CJJMA JMA;
//---    
   for(bar=first; bar<rates_total; bar++)
     {
      //---    FATL
      FATL=0.0;
      for(int iii=0; iii<FATLSize; iii++)
         FATL+=FATLTable[iii]*PriceSeries(IPC,bar-iii,open,low,high,close);
      //---    JJMASeries. 
      //---  Phase  Length      (Din = 0) 
      jfatl=JMA.JJMASeries(fstart,prev_calculated,rates_total,0,Phase_,Length_,FATL,bar,false);
      //---       FATL
      ExtLineBuffer[bar]=jfatl+dPriceShift;
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
